<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
    <title>Device Registration</title>

    <link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

    <script src='../js/meti_merged.js'></script>
    <script src='../js/meti_utils.js'></script>

    <style>
        html {
            visibility: hidden;
        }
    </style>

</head>

<body>
    <div w3-include-html="meti_bst.html"></div>

    <div class="container">
        <div class="row">
            <main role="main" class="col-sm-12 col-md-8 col-lg-6 pt-2">
                <div class="row">
                    <h5 class="p-1">Device Registration</h5>
                    <div id="loader_param" class="meti_loader m-1" style="width:1.5rem; height:1.5rem">
                    </div>
                </div>
                <form id="formID">
                    <div class="border border-primary p-2">
                        <div class="mqtt_settings">
                            <!-- Client ID -->
                            <div class="form-group p-0 m-1 row">
                                <label class="col-4" for="sel_clientId" align="center" >Client ID</label>
                                <input type="text" id="sel_clientId" name="sel_clientId"
                                    class="col-8 form-control form-control-sm" readonly>
                            </div>
                        </div>

                        <div class="col-sm-12 form-group row mt-4 mb-1">
                            <button type="button" id="button_cancel"
                                class="btn btn-warning col ml-4 mr-4">Cancel</button>
                            <div id="loader_register" class="meti_loader m-1" style="width:1.5rem; height:1.5rem">
                            </div>

                            <button type="button" id="button_register" disabled
                                class="btn btn-success col ml-4 mr-4">Register</button>
                        </div>
                    </div>
                </form>
            </main>
        </div>
</body>
</html>

<script>
    w3IncludeHTML();
    driver_id = "1";
    g_4_20mA_driver = "";

    $(document).ready(function () {
        // display all items
        document.getElementsByTagName("html")[0].style.visibility = "visible";

        $("#button_register").on("click", function () {
            var r = confirm("Register this device?");
            if (r == true) {
                register_device();
            }
        });

        $("#button_cancel").on("click", function () {
            document.location.href = "index.html";
        });

        function load_form_data() {

        }

        function register_device() {
            var debug = 0;

            $("#loader_register").css("display", "block");

            var url = "https://test.meti.in/test/index.php/quickiot/register_device";
            if (LOCAL_HOST == true) {
                url = "http://localhost/play/index.php/quickiot/register_device";
            }

            var type = 'POST';
            var data = {
                app_key: "quickIoT",
                api_key: "4d5302f9e0c38f076673e62096db3a4a",
                driver_id: "123420",   //Narayan this has to be changed....
                driver_version: "1",
                // Narayan this has to be actual device id
                device_id: g_device_id,
            };

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (responseText) {
                    $("#loader_register").css("display", "none");
                    response = JSON.parse(responseText)
                    var result = response.result;
                    if (result == 1) {
                        g_4_20mA_driver.active = true;
                        g_4_20mA_driver.dev_key = response.dev_key;
                        saveDriver();
                    }
                    else if (result == 2) {
                        alert(response.error);
                    }
                },
                error: function (jqXHR, exception, response) {
                    $("#loader_register").css("display", "none");
                    alert('POST Error!! Unable to register the device...');
                }
            });
        }

        function saveDriver() {
            $("#loader_register").css("display", "block");

            var driver_file = JSON.stringify(g_4_20mA_driver);

            var data = {};
            data["driver_id"] = driver_id;

            MAX_POST_SIZE = 1000;
            var fileSize = driver_file.length;
            ctr = 0;
            while (fileSize > 0) {
                start = ctr * MAX_POST_SIZE;
                end = start + MAX_POST_SIZE;
                data["driver_file" + ctr] = driver_file.substring(start, end);
                fileSize = fileSize - MAX_POST_SIZE;
                ctr++;
            }
            data['driver_chunks'] = ctr;
            data['fileSize'] = driver_file.length;

            var url = "/saveNewModbusDriver";
            if (LOCAL_HOST == true) {
                url = "http://localhost/play/index.php/quickiot_simulate/save_driver_to_device";
            }
            var type = 'POST';

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    $("#loader_register").css("display", "none");

                    var result = response.result;
                    if (result == 1) {
                        alert(response.message);
                    }
                    else if (result == 0) {
                        console.log(response.message);
                    }
                },
                error: function (jqXHR, exception, response) {
                    $("#loader_register").css("display", "none");
                    alert('POST Error!! Unable to save driver');
                }
            });
        }

        function noSensorData(response) {
            $("#loader_param").css("display", "none");
            console.log("POST Error...")
        }

        function gotDriver(response) {
            if (response.driver_id === undefined) {
                g_4_20mA_driver = "";
                alert("Driver file not found in device... Contact support...")
            } else {
                g_4_20mA_driver = response;
                $("#button_register").prop("disabled", false);
            }
            $("#loader_param").css("display", "none");
        }

        function get4_20mA_driver(response) {
            $("#sel_clientId").val(response.dev_id);
            getModbusDriverById(driver_id, gotDriver);
        }

        //********* Call all start up functions after this line *******//

        setTimeout(function () {
            getDeviceParams(get4_20mA_driver, noSensorData);
        }, 750);

        $("#loader_param").css("display", "block");

        $("#formID").validationEngine();
    });

</script>